<template>
  <b-container fluid>
    <b-row>
      <b-col md="4" offset-md="4">
        <b-alert
          md="2"
          offset-md="5"
          :show="dismissCountDown"
          dismissible
          variant="warning"
          @dismissed="dismissCountDown = 0"
          @dismiss-count-down="countDownChanged"
        >
          {{ this.msg }}
        </b-alert>
      </b-col>
    </b-row>
    <b-row class="my-1">
      <b-col md="2" offset-md="5">
        <b-form-input
          id="input-default"
          type="email"
          placeholder="email"
          v-model="email"
        ></b-form-input>
      </b-col>

      <b-col md="2" offset-md="5">
        <b-form-input
          id="input-default"
          type="password"
          placeholder="Password"
          v-model="password"
          class="align-center"
        ></b-form-input>
      </b-col>
    </b-row>
    <b-col cols="12">
      <b-button variant="success" @click="this.connect">Sign in</b-button>
    </b-col>
  </b-container>
</template>

<script>
import Vue from "vue";
import axios from "axios";
import router from "@/router";
import { getUserId, getUserName } from "@/router/auth.js";
import "bootstrap/dist/css/bootstrap.css";
import "bootstrap-vue/dist/bootstrap-vue.css";
import config from "@/Utils/config.json";
import { AlertPlugin } from "bootstrap-vue";
Vue.use(AlertPlugin);
import { BFormInput } from "bootstrap-vue";
import { BButton } from "bootstrap-vue";
Vue.component("b-form-input", BFormInput);
Vue.component("b-button", BButton);

export default {
  name: "Log",
  data() {
    return {
      dismissSecs: 5,
      dismissCountDown: 0,
      msg: "",
      types: [
        "text",
        "number",
        "email",
        "password",
        "search",
        "url",
        "tel",
        "date",
        "time",
        "range",
        "color",
      ],
      username: "",
      email: "",
    };
  },
  methods: {
    countDownChanged(dismissCountDown) {
      this.dismissCountDown = dismissCountDown;
    },
    showAlert(msg) {
      this.dismissCountDown = this.dismissSecs;
      this.msg = msg;
    },
    connect() {
      var bodyFormData = new FormData();
      bodyFormData.append(this.password, this.email);
      const request = {
        session: {
          email: this.email,
          password: this.password,
        },
      };

      axios({
        method: "post",
        url: `${config.config.res_endpoint}api/sign_in`,
        data: request,
      })
        .then((response) => {
          localStorage.setItem("accesToken", response.data.data.token);
          this.showAlert(`welcome ${getUserName(getUserId())} on your pannel;`);
          router.push("/Home").then(window.location.reload());
        })
        .catch((error) => {
          this.showAlert(`error on the connection : ${error}`);
        });
    },
  },
};
</script>

<style>
#input {
  width: 40%;
  margin-top: 8%;
  align-content: center;
}

#input button {
  margin-left: 15%;
  margin-top: 5%;
}
</style>